# Copyright (C) 2011-2023 RhodeCode GmbH
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License, version 3
# (only), as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# This program is dual-licensed. If you wish to learn more about the
# RhodeCode Enterprise Edition, including its added features, Support services,
# and proprietary license terms, please see https://rhodecode.com/licenses/

import hashlib
from rhodecode.lib.str_utils import safe_bytes, safe_str


def md5(s):
    return hashlib.md5(s).hexdigest()


def md5_safe(s, return_type=''):

    val = md5(safe_bytes(s))
    if return_type == 'str':
        val = safe_str(val)
    return val


def sha1(s):
    return hashlib.sha1(s).hexdigest()


def sha1_safe(s, return_type=''):
    val = sha1(safe_bytes(s))
    if return_type == 'str':
        val = safe_str(val)
    return val


def sha256(s):
    return hashlib.sha256(s).hexdigest()


def sha256_safe(s, return_type=''):
    val = sha256(safe_bytes(s))
    if return_type == 'str':
        val = safe_str(val)
    return val
